using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {

       public static void Main()
       {
CategoryBuilder.Create("Army of the Czech Republic", "", ModAPI.LoadSprite("Category.png"));
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "<color=#495434>AOTCR <color=white>Soldier", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Soldier.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/Soldier.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "<color=#495434>AOTCR <color=white>Soldier (Rolled)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/SoldierSleeve.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/SoldierSleeve.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "<color=#495434>AOTCR <color=white>Soldier (Mask)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/SoldierMask.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/SoldierMask.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "<color=#495434>AOTCR <color=white>Soldier (Mask/Rolled)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/SoldierMaskSleeve.png"),
        AfterSpawn = (Instance) => 
        {
        var skin = ModAPI.LoadTexture("Sprite/SoldierMaskSleeve.png");
        var flesh = ModAPI.LoadTexture("Flesh.png");
        var bone = ModAPI.LoadTexture("Bone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone, 10);
        }
    }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>Petris P 3001 Helmet (Cover)",
        DescriptionOverride = "Wz. 93 Pantera Helmet Cover", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/HelmetCover.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/HelmetCover.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "Head";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/HelmetCover.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>Petris P 3001 Helmet",
        DescriptionOverride = "Wz. 93 Pantera Helmet Cover", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Helmet.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/Helmet.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "Head";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/Helmet.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>M95 Plate Carrier (Upper)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorUpper.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorUpper.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorUpper.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>M95 Plate Carrier (Lower)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorLower.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorLower.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "MiddleBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorLower.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>FENIX COMBAT Ballistic Protective Vest (Upper)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorUpperFenix.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorUpperFenix.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorUpperFenix.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>FENIX COMBAT Ballistic Protective Vest (Lower)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/ArmorLowerFenix.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/ArmorLowerFenix.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "MiddleBody";
            prop.armorTier = 250;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/ArmorLowerFenix.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>MNS-2000 Loadbearing Equipment (Upper)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/LoadUpper.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/LoadUpper.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 50;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/LoadUpper.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>MNS-2000 Loadbearing Equipment (Lower)", 
        DescriptionOverride = "", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/LoadLower.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/LoadLower.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "MiddleBody";
            prop.armorTier = 50;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/LoadLower.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "<color=#495434>AOTCR <color=white>Rugsack (Lower)", 
        DescriptionOverride = "Thank sturmz for not telling me name.", 
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Backpack.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/Backpack.png",10f);

            if (!Instance.GetComponent<ArmorBehaviour>())
            Instance.AddComponent<ArmorBehaviour>();

            ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

            ArmorProperties prop = new ArmorProperties();
                        
            prop.armorPiece = "UpperBody";
            prop.armorTier = 3;
            prop.scaleOffset = new Vector3(.0f, .0f);
            prop.offset = new Vector3(.0f, .0f);
            prop.sprite = "Sprite/Backpack.png";

            armor.prop = prop;
            armor.SetProperties();

            ArmorProperties[] armProp = new ArmorProperties[0];           
            Instance.FixColliders();
      }
   }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
        NameOverride = "<color=#495434>AOTCR <color=white>CZ805 BREN", 
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Bren.png"), 
        AfterSpawn = (Instance) => 
        {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/Bren.png",10f);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
        NameOverride = "<color=#495434>AOTCR <color=white>CZ Skorpion EVO A1", 
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Army of the Czech Republic"),
        ThumbnailOverride = ModAPI.LoadSprite("View/Evo.png"), 
        AfterSpawn = (Instance) => 
        {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprite/Evo.png",10f);
        }
    }
);

        }
    }
}